﻿MusicOff        = 0     ; byte  флаг музыка вкл/выкл.
DopplerEffect   = 1     ; byte  частота звука, изменяемая со временем
AccomplishPyramid = 34  ; word  номер пирамиды, до которой дошли
GrownWallsPtr   = 36    ; word  указатель на структуру блока параметров зарастающих стен комнаты

SpriteParam     = 40    ; начало блока данных спрайтов, размер 040 байтов

; Структура параметров ГГ/Охотника для вывода на экран
; смещения до элементов в структуре от базы
DR$ScrAddrSav   = 0     ; адрес экрана для вывода спрайта ГГ/Охотника для функции сохранения/восстановления экрана
DR$SprWidthSav  = 10    ; ширина спрайта ГГ/Охотника для функции сохранения/восстановления экрана
DR$SprWidthOut  = 11    ; ширина спрайта ГГ/Охотника для функции вывода спрайта на экран
DR$ScrAddrOut   = 20    ; адрес экрана для вывода спрайта ГГ/Охотника для функции вывода спрайта на экран
DR$SpriteAdr    = 30    ; адрес спрайта в массиве для ГГ/Охотника

; смещения до элементов в структуре по индексу
ScrAddrSav      = SpriteParam + DR$ScrAddrSav
SprWidthSav     = SpriteParam + DR$SprWidthSav
SprWidthOut     = SpriteParam + DR$SprWidthOut
ScrAddrOut      = SpriteParam + DR$ScrAddrOut
SpriteAdr       = SpriteParam + DR$SpriteAdr

ScrBuffer       = 104
;104-171 - буфер сохранения экрана под человечком
;214-301 - буфер сохранения экрана под охотником1
;324-411 - буфер сохранения экрана под охотником2
;434-521 - буфер сохранения экрана под охотником3

ThreasureParamPtr = 172 ; word  указатель на структуру количества и адресов сокровищ
ThreasuresNum   = 174   ; word  количество сокровищ
WallColorMask   = 176   ; word  адрес цветовой маски для стен.
LadderColorMask = 200   ; word  адрес цветовой маски для лестниц.
CharColorMask   = 202   ; word  маска цвета символа
RoomOffset      = 204   ; word  смещение, показывающее, в какой мы сейчас половинке комнаты: 0, 40, ещё есть значение 20 - промежуточное
GGHaveEquip     = 206   ; byte флаг, что в руках у человечка, >0 - кирка, <0 - нож, 0 - пусто
CatchKeyFlg     = 207   ; byte флаг, 1 - взяли ключ для выхода из пирамиды, 0 - нет, -1 - взяли, больше не отрабатывать проверку взятия
PressButton     = 210   ; byte код нажатой клавиши
ThrowKnife      = 211   ; byte флаг, что нож летит: 200 - нож никуда не летит, может вообще не подобран,
                        ;   это ещё и счётчик:  177..1 - летит; 0 - остановился, должен начать падать.
OffsXFlyKnife   = 212   ; byte смещение по X летящего ножа
SprNFlyKnife    = 213   ; byte номер спрайта летящего ножа

KnifeAddr       = 544   ; word адрес летящего ножа в буфере лабиринта
CurrScoreBuf    = 546   ; 6 байтов текущего числа в аски форме
ChangeRoomFlg   = 554   ; byte флаг смены полукомнаты. при движении ГГ сменился лабиринт, и старые значения в буферах стали невалидны
GGCatched       = 555   ; byte флаг, охотник поймал человечка
word_556        = 556   ; byte
CatchThreasureFlag = 557 ; byte флаг, что подобрали сокровище

DoorsBlock      = 560   ; начало блока данных размер 10 байтов
EntryDoor       = DoorsBlock                ; word адрес входной двери
ExitDoor        = DoorsBlock + 2            ; word адрес выходной двери

; Структура параметров двери
; смещения до элементов в структуре от базы
DO$DoorAddr     = 0     ; адрес двери
DO$Closed       = 4     ; флаг: 0 - дверь закрыта; !0 - дверь открыта
; смещения до элементов в структуре по индексу
DoorAddress     = DoorsBlock + DO$DoorAddr  ; word адрес двери
ClosedDoor      = DoorsBlock + DO$Closed    ; byte флаг ключа у двери 0 - ключ не взят; !0 - ключ взят, дверь открыта

Humanoid        = 600   ; начало блока данных размер 46 байтов, 570-600 тоже занято

DrawEntryFlag   = 646   ; byte флаг, что можно рисовать вход/выход
                        ; 0 - нельзя, >0 - можно, <0 - уже нарисовали, больше не надо
TrHBlinkingFlg  = 647   ; byte флаг мигания ореола шара
BgrMusPtr       = 650   ; word Указатель на текущую ноту фоновой музыки
BgrMusTempo     = 652   ; word Длительность текущей ноты
BgrMusTone      = 654   ; word тон текущей ноты

; 656..665  - 10 байтов параметры связанные с верчением головой ГГ/Охотника

GGFlag          = 666   ; byte для ГГ - 0, для охотника - !0
                        ; флаг - висеть и не падать в только что пробитую дыру киркой вниз.
MoveToBack      = 667   ; byte Флаг передвижения в обратном направлении по пирамидам
CurrPyramid     = 670   ; word Номер текущей пирамиды, отсчёт с 1
RndBuff         = 672   ; word Буфер генератора RND
HuntFoVVert     = 674   ; word расстояние по вертикали на котором охотник замечает ГГ
                        ; и начинает его преследовать
HuntFoVHorz     = 676   ; word расстояние по горизонтали на котором охотник замечает ГГ
                        ; и начинает его преследовать



; Структура параметров ГГ/Охотника
; смещения до элементов в структуре от базы
HP$StartCoord   = -10
HP$Coord        = 0     ; адрес в буфере комнаты Room
HP$OffsetX      = 10    ; смещение движения по Х
HP$OffsetY      = 11    ; смещение движения по Y
HP$AnimStage    = 20    ; номер этапа в анимации действий (0..4)
HP$AnimType     = 21    ; номер анимации для действий (0..7)
HP$DirMove      = 30    ; флаг направления движения, 0 - вправо, !0 - влево
HP$ColorMask    = 31    ; маска цвета охотника, для ГГ не используется
; параметры только для охотников
HP$HuntParam    = 36    ; старшие 4 бита из параметра охотника, фактически число 0..4 ( из данных таблицы)
HP$HuntState    = 37    ; состояние охотника, начальное = -14, если 0 - активен
HP$HuntTurnHead = 56    ; флаг, что нужно поворачивать голову
HP$HuntTHCnt    = 57    ; счётчик, связанный с верчением головой

; смещения до элементов в структуре по индексу
StartCoord      = Humanoid + HP$StartCoord ; массив начальных координат для ГГ/Охотника
GGCoord         = Humanoid + HP$Coord   ; начало параметров ГГ, используется как самостоятельная ячейка
HunterCoord     = GGCoord + 2           ; начало параметров охотников
Coordinate      = GGCoord               ; используется как база для индекса
OffsetX         = Humanoid + HP$OffsetX
OffsetY         = Humanoid + HP$OffsetY
AnimStage       = Humanoid + HP$AnimStage
AnimType        = Humanoid + HP$AnimType
DirMove         = Humanoid + HP$DirMove
ColorMaskHun    = Humanoid + HP$ColorMask
; параметры только для охотников
HuntParam       = Humanoid + HP$HuntParam
HuntState       = Humanoid + HP$HuntState   ; состояние охотника (счётчик его жизни, зарождения из пузыря)
; у ГГ эти параметры используются для зарастающих стен
HuntTurnHead    = Humanoid + HP$HuntTurnHead 
HuntTHCnt       = Humanoid + HP$HuntTHCnt

; адреса экрана
TopScreen       = 42000 ; адрес экрана, с которого начинается игровое поле
ReqExitScr      = 60000 ; адрес для вывода запроса на выход из игры
GameNameScr1    = 75600 ; адрес начала первой строки
GameNameScr2    = 77000 ; адрес начала второй строки

; адреса в ПЗУ монитора БК-0010
StarsSplash     = 102400    ; используется как источник случайных данных для Падающих звёзд в заставке
BackgroundSplash = 104000   ; используется как источник случайных данных для рисования почвы в заставке
ROMCmdRti       = 101330    ; Указатель на команду RTI
ROMEXitMon      = 100274    ; Выход в монитор

; номера тайлов спрайтов динамических объектов

TD$GGJumpRight      = 00. ; #00: n=1, w=3, offs=000000  человечек шагает вправо (возможно - прыжок)
TD$GGJumpLeft       = 01. ; #01: n=2, w=3, offs=000066  человечек шагает влево (возможно - прыжок)
TD$GGWatchRight     = 02. ; #02: n=2, w=2, offs=000154  человечек стоит и смотрит вправо
TD$GGWatchLeft      = 03. ; #03: n=2, w=2, offs=000220  человечек стоит и смотрит влево
TD$GGStopRight      = 04. ; #04: n=1, w=3, offs=000264  человечек заканчивает шаг вправо (возможно - спуск по лестнице)
TD$GGStopLeft       = 05. ; #05: n=2, w=3, offs=000352  человечек заканчивает шаг влево
TD$GGStepRight      = 06. ; #06: n=1, w=2, offs=000440  человечек шагает вправо
TD$GGStepLeft       = 07. ; #07: n=3, w=2, offs=000504  человечек шагает влево
TD$GGStartRight     = 08. ; #08: n=1, w=3, offs=000550  человечек делает шаг вправо (возможно - подъём по лестнице)
TD$GGStartLeft      = 09. ; #09: n=2, w=3, offs=000636  человечек делает шаг влево
TD$GGHWatchRight    = 10. ; #10: n=1, w=3, offs=000724  человечек с киркой стоит и смотрит вправо
TD$GGHWatchLeft     = 11. ; #11: n=2, w=3, offs=001012  человечек с киркой стоит и смотрит влево
TD$GGHStopRight     = 12. ; #12: n=1, w=3, offs=001100  человечек с киркой заканчивает шаг вправо
TD$GGHStopLeft      = 13. ; #13: n=2, w=3, offs=001166  человечек с киркой заканчивает шаг влево
TD$GGHStepRight     = 14. ; #14: n=0, w=3, offs=001254  человечек с киркой шагает вправо
TD$GGHStepLeft      = 15. ; #15: n=3, w=3, offs=001342  человечек с киркой шагает влево
TD$GGHStartRight    = 16. ; #16: n=1, w=3, offs=001430  человечек с киркой делает шаг вправо
TD$GGHStartLeft     = 17. ; #17: n=2, w=3, offs=001516  человечек с киркой делает шаг влево
TD$GGKWatchRight    = 18. ; #18: n=2, w=3, offs=001604  человечек с ножом стоит и смотрит вправо
TD$GGKWatchLeft     = 19. ; #19: n=1, w=3, offs=001672  человечек с ножом стоит и смотрит влево
TD$GGKStopRight     = 20. ; #20: n=1, w=3, offs=001760  человечек с ножом заканчивает шаг вправо
TD$GGKStopLeft      = 21. ; #21: n=2, w=3, offs=002046  человечек с ножом заканчивает шаг влево
TD$GGKStepRight     = 22. ; #22: n=1, w=3, offs=002134  человечек с ножом шагает вправо
TD$GGKStepLeft      = 23. ; #23: n=2, w=3, offs=002222  человечек с ножом шагает влево
TD$GGKStartRight    = 24. ; #24: n=1, w=3, offs=002310  человечек с ножом делает шаг вправо
TD$GGKStartLeft     = 25. ; #25: n=2, w=3, offs=002376  человечек с ножом делает шаг влево
TD$GGKStartSwingRight = 26. ; #26: n=1, w=3, offs=002464  человечек начинает замах ножом вправо
TD$GGKStartSwingLeft = 27. ; #27: n=2, w=3, offs=002552  человечек начинает замах ножом влево
TD$GGKSwingRight    = 28. ; #28: n=0, w=3, offs=002640  человечек размахнулся ножом вправо
TD$GGKSwingLeft     = 29. ; #29: n=3, w=3, offs=002726  человечек размахнулся ножом влево
TD$GGHStartHitRight = 30. ; #30: n=2, w=3, offs=003014  человечек начинает удар киркой вправо
TD$GGHStartHitLeft  = 31. ; #31: n=1, w=3, offs=003102  человечек начинает удар киркой влево
TD$GGHHitRight      = 32. ; #32: n=2, w=3, offs=003170  человечек ударил киркой вправо
TD$GGHHitLeft       = 33. ; #33: n=1, w=3, offs=003256  человечек ударил киркой влево
TD$GGFrontBegin     = 34. ; #34: n=2, w=2, offs=003344  человечек анфас начало
TD$GGFrontEnd       = 35. ; #35: n=2, w=2, offs=003410  человечек анфас конец
TD$BubbleStart      = 36. ; #36: n=2, w=2, offs=003454  пузырь начал формироваться
TD$BubbleMax        = 37. ; #37: n=1, w=4, offs=003520  пузырь в максимальной фазе
TD$BubbleBurst      = 38. ; #38: n=1, w=4, offs=003630  пузырь лопнул

TD$HuntJumpRight    = 00. ; #00: n=1, w=3, offs=000000  охотник шагает вправо (возможно - прыжок)
TD$HuntJumpLeft     = 01. ; #01: n=2, w=3, offs=000066  охотник шагает влево (возможно - прыжок)
TD$HuntWatchRight   = 02. ; #02: n=2, w=2, offs=000154  охотник стоит и смотрит вправо
TD$HuntWatchRigth   = 03. ; #03: n=2, w=2, offs=000220  охотник стоит и смотрит влево
TD$HuntStopRight    = 04. ; #04: n=1, w=3, offs=000264  охотник заканчивает шаг вправо (возможно - спуск по лестнице)
TD$HuntStopLeft     = 05. ; #05: n=2, w=3, offs=000352  охотник заканчивает шаг влево
TD$HuntStepRight    = 06. ; #06: n=1, w=2, offs=000440  охотник шагает вправо
TD$HuntStepLeft     = 07. ; #07: n=3, w=2, offs=000504  охотник шагает влево
TD$HuntStartRight   = 08. ; #08: n=1, w=3, offs=000550  охотник делает шаг вправо (возможно - подъём по лестнице)
TD$HuntStartRignt   = 09. ; #09: n=2, w=3, offs=000636  охотник делает шаг влево


; Номера тайлов спрайтов статических объектов
TS$Floor            = -1    ; пол непробиваемый
TS$Space            = 0.    ; 0 - пусто
TS$Wall             = 1.    ; 1 - стена сплошная
TS$Threasure        = 2.    ; 2 - сокровище
TS$Knife            = 3.    ; 3 - нож
TS$Hack             = 4.    ; 4 - кирка
TS$ThrShineUp       = 5.    ; 5 - мигание сокровища сверху
TS$ThrShineLeft     = 6.    ; 6 - мигание сокровища слева
TS$ThrShineRight    = 7.    ; 7 - мигание сокровища справа
; кажись у меня лестницы перепутаны
TS$LadderUppLeft    = 8.    ; 8 - лестница левая верх
TS$LadderDnpLeft    = 9.    ; 9 - лестница левая низ
TS$LadderUppRight   = 10.   ; 10 - лестница правая верх
TS$LadderDnpRight   = 11.   ; 11 - лестница правая низ
TS$FlyKnife135      = 12.   ; 12 - летящий нож 135 град.
TS$FlyKnife225      = 13.   ; 13 - летящий нож 225 град.
TS$FlyKnife315      = 14.   ; 14 - летящий нож 315 град.
TS$FlyKnife045      = 15.   ; 15 - летящий нож 45 град.
TS$GreenWall        = 16.   ; 16 - стена зелёная, в которой открывается проход на вход и выход из пирамиды
TS$Key              = 17.   ; 17 - ключ
; тут как и выше, сперва левое потом правое, а может быть нужно
; как фактически - сперва правое потом левое
TS$BreachLeft       = 18.   ; 18 - что-то справа
TS$BreachRight      = 19.   ; 19 - что-то слева
TS$OpnBreachLeft    = 20.   ; 20 - 0 справа (2 часть односторонней двери правой)
TS$ClosBreachRight  = 21.   ; 21 - Н слева  (1 часть односторонней двери правой)
TS$ClosBreachLeft   = 22.   ; 22 - Н справа (1 часть односторонней двери левой)
TS$OpnBreachRight   = 23.   ; 23 - 0 слева  (2 часть односторонней двери левой)
TS$HalfWallLeft     = 24.   ; 24 - полкирпича справа
TS$OpnClsBrchLeft   = 25.   ; 25 - 0Н слева
TS$OpnClsBrchRight  = 26.   ; 26 - Н0 справа
TS$HalfWallRight    = 27.   ; 27 - полкирпича слева


; анимации:
; 0 - ходьба / стоять
;       stage = 4
; 1 - малый (низкий) прыжок (когда сверху что-нибудь мешает) / проход через одностороннюю дверь
;       stage = 10
; 2 - большой (высокий) прыжок
;       stage = 20
; 3 - подпрыгнуть на месте чтоб взять ключ или кирку
;       stage = 0
; 4 - свободное падение
;       stage = 2
; 5 - стучать киркой вбок
;       stage = 10
; 6 - стучать киркой вниз
;       stage = 10
; 7 - бросок ножа
;       stage = 4

; звуки
; 0 - звук броска ножа / конец полёта ножа
; 2 - попали ножом в охотника
; 4 - звук удара киркой
; 6 - звук подбора сокровища
; 10 - звук летящего ножа
; 12 - звук рождения охотника
; 14 - звук упавшего ножа


; элементы лабиринта:
; -1 - пол непробиваемый
; 0 - пусто
; 1 - стена пробиваемая
; 200..207 - сокровище, цвета 0..7
; 3 - нож
; 4 - кирка

; 8 - лестница левая верх
; 9 - лестница левая низ
; 10 - лестница правая верх
; 11 - лестница правая низ

; 16 - стена зелёная, в которой открывается проход на вход и выход из пирамиды
; 17 - ключ
; 18 - что-то справа
; 19 - что-то слева
; 20 - 0 справа (2 часть односторонней двери правой)
; 21 - Н слева  (1 часть односторонней двери правой)
; 22 - Н справа (1 часть односторонней двери левой)
; 23 - 0 слева  (2 часть односторонней двери левой)
; 24 - полкирпича справа
; 25 - 0Н слева
; 26 - Н0 справа
; 27 - полкирпича слева

.end